
int_T pizza_initialize(real_T *pos, int_T ireset, SimStruct *S)
{
	int_T i;
	real_T ttt;

	int_T *piwrk=ssGetIWork(S);
	real_T *prwrk=ssGetRWork(S);

	int_T ilink;

	ilink = (int_T) (*(mxGetPr(LINK_ID)));

#ifndef MATLAB_MEX_FILE

/*	reset encoder counters to zero */
	if (ireset) {
		ec_EL5101_enc_init_chan(1,ilink);	/*##################################*/
		ec_EL5101_enc_init_chan(2,ilink);	/*##################################*/
		ec_EL5101_enc_init_chan(3,ilink);	/*##################################*/
		ec_EL5101_enc_init_chan(4,ilink);	/*##################################*/
		/*ec_EL5101_enc_init_chan(1,S);	/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
		/*ec_EL5101_enc_init_chan(2,S);	/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
		/*ec_EL5101_enc_init_chan(3,S);	/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
		/*ec_EL5101_enc_init_chan(4,S);	/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
	}

	for (i=0;i<4;i++) {
	  pos[i]=0.0;
	}

	ec_EL1008_di_read_chan(&ttt, 0, ilink*2-1);
	epd(0)=ttt;
	epdtar(0)=1.0-epd(0);
	if ((int_T) epd(0)==1) {
	  homdir(0)=-1.0;
	} else {
	  homdir(0)=1.0;
	}

	ec_EL1008_di_read_chan(&ttt, 2, ilink*2-1);
	epd(1)=ttt;
	epdtar(1)=1.0-epd(1);
	if ((int_T) epd(1)==1) {
	  homdir(1)=1.0;
	} else {
	  homdir(1)=-1.0;
	}

	ec_EL1008_di_read_chan(&ttt, 4, ilink*2-1);
	epd(2)=ttt;
	epdtar(2)=1.0-epd(2);
	if ((int_T) epd(2)==1) {
	  homdir(2)=1.0;
	} else {
	  homdir(2)=-1.0;
	}

	ec_EL1008_di_read_chan(&ttt, 7, ilink*2-1);
	epd(3)=-ttt+1.0;
	epdtar(3)=1.0-epd(3);
	if ((int_T) epd(3)==1) {
	  homdir(3)=1.0;
	} else {
	  homdir(3)=-1.0;
	}
	
/*	printf("at start: %f %f %f %f\n",epd(0),epd(1),epd(2),epd(3));*/
/*	printf("targets : %f %f %f %f\n",epdtar(0),epdtar(1),epdtar(2),epdtar(3));*/
#endif

#ifdef PIZZAMODEL
	homdir(0)=1.0;
	epdtar(0)=1.0;

	homdir(1)=-1.0;
	epdtar(1)=1.0;

	homdir(2)=-1.0;
	epdtar(2)=1.0;

	homdir(3)=-1.0;
	epdtar(3)=1.0;
#endif

	return 1;
}





int_T pizza_start_homing(real_T *pos, real_T t, SimStruct *S)
{
	int_T i;

	real_T *x=ssGetContStates(S);

	int_T *piwrk=ssGetIWork(S);
	real_T *prwrk=ssGetRWork(S);

/*	initialize jogging parameters */

	for (i=0;i<4;i++) {
		if (iaxis(i)==1) {
			jog_ini(pos[i],t,homdir(i)*vh(i),0.1,500.0,i,S);
		}
	}

/*	initialize controller states */

	pid_ini(x,pos);

	return 1;
}





int_T pizza_homing_dif(real_T *dx, real_T *x, real_T *pos, real_T t, SimStruct *S)
{
	int_T i;
	real_T qref[4],vref[4],aref[4];

	int_T *piwrk=ssGetIWork(S);
	real_T *prwrk=ssGetRWork(S);

	for (i=0;i<4;i++) {
		if (iaxis(i)==1) {
			jog_get(&qref[i],&vref[i],&aref[i],t,i,S);
		}
	}

	pid_dif(dx,x,pos,qref);

	return 1;
}





int_T pizza_homing_out(real_T *u, real_T *vel, real_T *x, real_T *pos, real_T t, SimStruct *S)
{
	int_T i;
	real_T qref[4],vref[4],aref[4];

	int_T *piwrk=ssGetIWork(S);
	real_T *prwrk=ssGetRWork(S);

	for (i=0;i<4;i++) {
		if (iaxis(i)==1) {
			  jog_get(&qref[i],&vref[i],&aref[i],t,i,S);
		}
	}

        pid_out(u,vel,x,pos,qref,vref,S);

#ifdef FFMASS
	for (i=0;i<4;i++) {	
		u[i]=u[i]+aref[i]/gain(i);
	}
#endif
#ifdef FFFRIC
	for (i=0;i<4;i++) {	
		u[i]=u[i]-visc(i)*vref[i]/gain(i);
	}
#endif
#ifdef FFVISC
	for (i=0;i<4;i++) {	
	  u[i]=u[i]-fric(i)*(2.0/PI)*atan(100.0*vref[i])/gain(i);
	}
#endif

	return 1;
}





int_T pizza_start_moving(real_T *pos, real_T t, SimStruct *S)
{
	int_T i;

	real_T *x=ssGetContStates(S);

	int_T *piwrk=ssGetIWork(S);
	real_T *prwrk=ssGetRWork(S);

	for (i=0;i<4;i++) {
		if (iaxis(i)==1) {
			p2p_ini(pos[i],t,target(i),movdir(i)*2.0*vh(i),0.3,100.0,i,S);
		}
	}

/*	initialize controller states */

	pid_ini(x,pos);

	return 1;
}





int_T pizza_moving_dif(real_T *dx, real_T *x, real_T *pos, real_T t, SimStruct *S)
{
	int_T i;
        real_T qref[4],vref[4],aref[4];

	int_T *piwrk=ssGetIWork(S);
	real_T *prwrk=ssGetRWork(S);

	for (i=0;i<4;i++) {
		if (iaxis(i)==1) {
			p2p_get(&qref[i],&vref[i],&aref[i],t,i,S);
		}
	}

	pid_dif(dx,x,pos,qref);

	return 1;
}





int_T pizza_moving_out(real_T *u, real_T *vel, real_T *x, real_T *pos, real_T t, SimStruct *S)
{
	int_T i;
	real_T qref[4],vref[4],aref[4];

	int_T *piwrk=ssGetIWork(S);
	real_T *prwrk=ssGetRWork(S);

	for (i=0;i<4;i++) {
		if (iaxis(i)==1) {
			p2p_get(&qref[i],&vref[i],&aref[i],t,i,S);
		}
	}

        pid_out(u,vel,x,pos,qref,vref,S);

#ifdef FFMASS
	for (i=0;i<4;i++) {
	  u[i]=u[i]+aref[i]/gain(i);
	}
#endif
#ifdef FFFRIC
	for (i=0;i<4;i++) {
	  u[i]=u[i]-visc(i)*vref[i]/gain(i);
	}
#endif
#ifdef FFVISC
	for (i=0;i<4;i++) {
	  u[i]=u[i]-fric(i)*(2.0/PI)*atan(1000.0*vref[i])/gain(i);
	}
#endif

	return 1;
}





int_T pizza_synchronize(real_T *pos, real_T *tar, real_T t, int_T sync_id, SimStruct *S)
{
        int_T i,iret,irep;
	real_T qref[4],vref[4],aref[4],ttt;

	real_T *x=ssGetContStates(S);

	int_T *piwrk=ssGetIWork(S);
	real_T *prwrk=ssGetRWork(S);

	int_T ilink;

	ilink = (int_T) (*(mxGetPr(LINK_ID)));

	switch (sync_id)
	{
	case PIZZAHOME:

#ifndef MATLAB_MEX_FILE
/*	  as long as epd change is not seen... */

          if (epd(0)!=epdtar(0)) {
	    ec_EL1008_di_read_chan(&ttt, 0, ilink*2-1);
	    epd(0)=ttt;
	    if (epd(0)==epdtar(0)) {
	      jog_stop(t,0,S);
	      epdtar(0)=-1.0;
	    }
	  }

          if (epd(1)!=epdtar(1)) {
	    ec_EL1008_di_read_chan(&ttt, 2, ilink*2-1);
            epd(1)=ttt;
	    if (epd(1)==epdtar(1)) {
	      jog_stop(t,1,S);
	      epdtar(1)=-1.0;
	    }
	  }

          if (epd(2)!=epdtar(2)) {
	    ec_EL1008_di_read_chan(&ttt, 4, ilink*2-1);
	    epd(2)=ttt;
	    if (epd(2)==epdtar(2)) {
	      jog_stop(t,2,S);
	      epdtar(2)=-1.0;
	    }
	  }

          if (epd(3)!=epdtar(3)) {
	    ec_EL1008_di_read_chan(&ttt, 7, ilink*2-1);
	    epd(3)=-ttt+1.0;
	    if (epd(3)==epdtar(3)) {
	      jog_stop(t,3,S);
	      epdtar(3)=-1.0;
	    }
	  }
	  
/*	  printf("%f %f %f %f\r",epd(0),epd(1),epd(2),epd(3));	 */
#endif

#ifdef PIZZAMODEL
          for (i=0;i<4;i++) {
	    if ((homdir(i)*pos[i]>=0.0) & ((int_T) epdtar(i)==1)) {
/*	      to be called only once... */
	      jog_stop(t,i,S);
	      epdtar(i)=-1.0;
	    }
	  }
#endif

#ifdef PIZZADEBUG
/*	  mexPrintf("jog_status=%d\n",jog_status(t,0,S)); */
/*	  mexPrintf("iaxis(0)=%f\n",iaxis(0)); */
#endif

	  irep=iaxis(0)*jog_status(t,0,S)+
	       iaxis(1)*jog_status(t,1,S)+
	       iaxis(2)*jog_status(t,2,S)+
	       iaxis(3)*jog_status(t,3,S);
#ifdef PIZZADEBUG
/*	  mexPrintf("irep=%d\n",(int_T) irep);*/
#endif
	  if (irep==iaxis(0)+iaxis(1)+iaxis(2)+iaxis(3)) {

#ifdef PIZZADEBUG
	    mexPrintf("Homing: synchronized %d axes at t=%f.\n",irep,t);
#endif

#ifndef MATLAB_MEX_FILE

/*	    initialize encoders link 0/1 */

	    ec_EL5101_enc_init_chan(1,ilink);		/*##################################*/
	    ec_EL5101_enc_init_chan(2,ilink);		/*##################################*/
	    ec_EL5101_enc_init_chan(3,ilink);		/*##################################*/
	    ec_EL5101_enc_init_chan(4,ilink);		/*##################################*/
	    /*ec_EL5101_enc_init_chan(1,S);	/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
	    /*ec_EL5101_enc_init_chan(2,S);	/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
	    /*ec_EL5101_enc_init_chan(3,S);	/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
	    /*ec_EL5101_enc_init_chan(4,S);	/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
	    for (i=0;i<4;i++) {

/*	      shift setpoint */

	      xstrt(i)=xstrt(i)-pos[i];

/*	      reset position */

	      pos[i]=0.0;

	    }

/*	    reinitialize differentiator states */

	    pid_ini(x,pos);
#endif

	    iret=1;
	  } else {
	    iret=0;
	  }

	  break;

	case PIZZAMOVE:

	  irep=iaxis(0)*p2p_status(t,0,S)+
	       iaxis(1)*p2p_status(t,1,S)+
	       iaxis(2)*p2p_status(t,2,S)+
	       iaxis(3)*p2p_status(t,3,S);
	  if (irep==iaxis(0)+iaxis(1)+iaxis(2)+iaxis(3)) {
#ifdef PIZZADEBUG
	    mexPrintf("Moving: synchronized %d axes at t=%f.\n",irep,t);
#endif

	    iret=1;
	  } else {
	    iret=0;
	  }

	  break;

	}

	return iret;
}





int_T pizza_ready_dif(real_T *dx, real_T *x, real_T t)
{
        int_T i;

        for (i=0;i<8;i++) {
	  dx[i]=0.0;
	}

	return 1;
}





int_T pizza_violation_dif(real_T *dx, real_T *x, real_T *pos, real_T t)
{

/*	we still need velocity estimates for airbag... */

	pid_dif(dx,x,pos,pos);

	return 1;
}
