
/* simple pid-controller */

#define	KGAIN		100

void pid_ini(real_T *xc, real_T *pos)
{
	int_T i;

	for (i=0;i<4;i++) {
	  xc[i]=pos[i];
	  xc[i+4]=0.0;
	}
}





void pid_dif(real_T *dxcdt, const real_T *xc, real_T *pos, real_T *qref)
{
	int_T i;

/*	xc[0...3] represent filtered positions */

	for (i=0;i<4;i++) {
	  dxcdt[i]=KGAIN*(pos[i]-xc[i]);
	  dxcdt[i+4]=qref[i]-pos[i];
	}
}





void pid_out(real_T *u, real_T *vel, const real_T *xc, real_T *pos, real_T *qref, real_T *vref, SimStruct *S)
{
	int_T i;

	int_T *piwrk=ssGetIWork(S);
	real_T *prwrk=ssGetRWork(S);

	for (i=0;i<4;i++) {

/*	  velocity estimates */

	  vel[i]=KGAIN*(pos[i]-xc[i]);

/*	  simple PID-controller */

	  u[i]=kp(i)*(qref[i]-pos[i])+kd(i)*(vref[i]-vel[i])+ki(i)*xc[i+4];
	  u[0]=u[0];
	}
}
